Package de.willuhn.jameica.hbci.passport

# Interface PassportHandle

All Superinterfaces:
  `Remote`

All Known Implementing Classes:
  `PassportHandleImpl`, `PassportHandleImpl`, `PassportHandleImpl`

public interface PassportHandle extends Remote
Bildet die direkte Verbindung zum HBCIHandler aus HBCI4Java ab.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`CONTEXT_CONFIG`
Identifier fuer den Persistent-Parameter mit der Config, aus der der Passport erstellt wurde.
`static final String`
`CONTEXT_SECMECHLIST`
Identifier fuer den Persistent-Parameter der Liste der TAN-Verfahren
`static final String`
`CONTEXT_TANMEDIALIST`
Identifier fuer den Persistent-Parameter mit der Liste der TAN-Medienbezeichnungen.
`static final String`
`CONTEXT_USERID_CHANGED`
Identifier fuer den Persistent-Parameter mit ggf geaenderter Kunden- und Benutzerkennung.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`callback(org.kapott.hbci.passport.HBCIPassport passport, int reason, String msg, int datatype, StringBuffer retData)`
Durch Implementierung dieses Callback-Aufrufs, kann sich das Passport-Handle in den HBCICallback einklinken.
`void`
`close()`
Schliesst den Passport.
`Konto[]`
`getKonten()`
Liefert ein Array mit Konto-Objekten, die aus dem Medium gelesen wurden.
`boolean`
`isOpen()`
Prueft, ob der Passport offen ist.
`org.kapott.hbci.manager.HBCIHandler`
`open()`
Oeffnet den Passport und liefert den HBCIHandler zrueck.

## Field Details

### CONTEXT_CONFIG

static final String CONTEXT_CONFIG
Identifier fuer den Persistent-Parameter mit der Config, aus der der Passport erstellt wurde.

See Also:
  - Constant Field Values

### CONTEXT_USERID_CHANGED

static final String CONTEXT_USERID_CHANGED
Identifier fuer den Persistent-Parameter mit ggf geaenderter Kunden- und Benutzerkennung.

See Also:
  - Constant Field Values

### CONTEXT_SECMECHLIST

static final String CONTEXT_SECMECHLIST
Identifier fuer den Persistent-Parameter der Liste der TAN-Verfahren

See Also:
  - Constant Field Values

### CONTEXT_TANMEDIALIST

static final String CONTEXT_TANMEDIALIST
Identifier fuer den Persistent-Parameter mit der Liste der TAN-Medienbezeichnungen.

See Also:
  - Constant Field Values

## Method Details

### open

org.kapott.hbci.manager.HBCIHandler open() throws RemoteException, de.willuhn.util.ApplicationException
Oeffnet den Passport und liefert den HBCIHandler zrueck. Diese Funktion wird von der HBCIFactory bei der Ausfuehrung von HBCIJobs verwendet.
Hinweis:Die Funktion hat den HBCIHandler fix und fertig vorkonfiguriert auszuliefern. Die HBCIFactory verwendet ihn direkt ohne weitere Parameter zu setzen.

Returns:
  Handler, der diese Verbindung repraesentiert.
Throws:
  `RemoteException` - muss geworfen werden, wenn die Initialisierung fehlschlaegt. Die Exeption sollte einen sinnvollen Fehlertext enthalten.
  `de.willuhn.util.ApplicationException`

### close

void close() throws RemoteException
Schliesst den Passport. Die Funktion wird von der HBCIFactory nach Durchfuehrung der HBCI-Jobs ausgefuehrt. In dieser Funktion sollte der HBCIHandler geschlossen werden.

Throws:
  `RemoteException`

### isOpen

boolean isOpen() throws RemoteException
Prueft, ob der Passport offen ist.

Returns:
  true, wenn er offen ist.
Throws:
  `RemoteException`

### getKonten

Konto[] getKonten() throws RemoteException, de.willuhn.util.ApplicationException
Liefert ein Array mit Konto-Objekten, die aus dem Medium gelesen wurden. Es wird niemals `null` zurueckgeliefert sondern hoechstens ein leeres Array.
Hinweis: Die Konten-Objekte duerfen nicht in der Datenbank gespeichert werden. Diese Entscheidung bleibt dem Anwender ueberlassen. Da der HBCIHandler von HBCI4Java ja Konto-Objekte vom Typ org.kapott.hbci.structures.Konto liefert, koennen diese via de.willuhn.jameica.hbci.server.util.Converter.HBCIKonto2JameicaKonto(Konto) in Fachobjekte des HBCI-Plugins konvertiert werden.

Returns:
  Array mit Konten, die dieser Passport anbietet.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`

### callback

boolean callback(org.kapott.hbci.passport.HBCIPassport passport, int reason, String msg, int datatype, StringBuffer retData) throws Exception
Durch Implementierung dieses Callback-Aufrufs, kann sich das Passport-Handle in den HBCICallback einklinken. Konkret wird das u.a. gebraucht, damit verbrauchte TANs gespeichert werden. Diese Funktion wird in der gleichnamigen Funktion von `HBCICallbackSWT` aufgerufen.

Parameters:
  `passport` -
  `reason` -
  `msg` -
  `datatype` -
  `retData` -
Returns:
  true, wenn der Handler den Callback behandeln konnte.
Throws:
  `Exception`
See Also:
  - `HBCICallback.callback(org.kapott.hbci.passport.HBCIPassport, int, java.lang.String, int, java.lang.StringBuffer)`